#include <iostream>

using namespace std;

int main()
{
    int n, a, b, ab, o, brojac0;
    cin >> n >> o >> a >> b >> ab;
    brojac0 = 0;
    for (int i = 1; i <= n; i++) {
        string krvnagrupapacijenta;
        int potrebanbrjedinica;
        cin >> krvnagrupapacijenta >> potrebanbrjedinica;
        if (krvnagrupapacijenta == "O") {
            if (potrebanbrjedinica > o) {
                cout << "nemoguce" << endl;
                break; }
                else {
                    if (brojac0 == 0) {
                        cout << "moguce" << endl;
                    }
                }

            
            cout << potrebanbrjedinica << " " << 0 << " " << 0 << " " << 0 << endl;
            o = o - potrebanbrjedinica;
        }
        if (krvnagrupapacijenta == "A") {
            if (potrebanbrjedinica > a + o) {
                cout << "nemoguce" << endl;
                break;
            }
                else {
                if (brojac0 == 0) {
                cout << "moguce" << endl;
                    }
                }
            if (potrebanbrjedinica <= a) {
                cout << 0 << " " << potrebanbrjedinica << " " << 0 << " " << 0 << endl;
                a = a - potrebanbrjedinica;
            }
            else {
                cout << potrebanbrjedinica - a << " " << a << " " << 0 << " " << 0 << endl;
                o = o - (potrebanbrjedinica - a);
                a = a - a;
                
                
            }
        }
        if (krvnagrupapacijenta == "B") {
            if (potrebanbrjedinica > b + o) {
                cout << "nemoguce" << endl;
                break;
            }
            else {
                if (brojac0 == 0) {
                cout << "moguce" << endl;
                    }
                }
            if (potrebanbrjedinica <= b) {
                cout << 0 << " " << 0 << " " << potrebanbrjedinica << " " << 0 << endl;
                b = b - potrebanbrjedinica;
            }
            else {
                cout << potrebanbrjedinica - b << " " << 0 << " " << b << " " << 0 << endl;
                o = o - (potrebanbrjedinica - b);
                b = b - b;
            }
        }
        if (krvnagrupapacijenta == "AB") {
            if (potrebanbrjedinica > a + b + o + ab) {
                cout << "nemoguce" << endl;
                break;
            }
                        else {
                if (brojac0 == 0) {
                cout << "moguce" << endl;
                    }
                }
            if (potrebanbrjedinica <= ab) {
                cout << 0 << " " << 0 << " " << 0 << " " << potrebanbrjedinica << endl;
                ab = ab - potrebanbrjedinica;
            }
            else if (potrebanbrjedinica >= ab && potrebanbrjedinica <= ab + a && potrebanbrjedinica >= ab + b) {
                cout << 0 << " " << potrebanbrjedinica - ab << " " << 0 << " " << ab << endl;
                a = a - (potrebanbrjedinica - ab);
                ab = 0;
                }
            else if (potrebanbrjedinica >= ab && potrebanbrjedinica >= ab + a && potrebanbrjedinica <= ab + b) {
                cout << 0 << " " << 0 << " " << potrebanbrjedinica - ab << " " << ab << endl;
                b = b - (potrebanbrjedinica - ab);
                ab = 0;
            }
            else if (potrebanbrjedinica >= ab && potrebanbrjedinica >= ab + a && potrebanbrjedinica >= ab + b && potrebanbrjedinica <= ab + a + b) {
            if (a >= b) {
            cout << 0 << " " << a << " " << potrebanbrjedinica - (a + ab) << " " << ab << endl;
            b = b - (potrebanbrjedinica - (a + ab));
            ab = 0;
            a = 0;
            }
            else {
            cout << 0 << " " << potrebanbrjedinica - (b + ab) << " " << b << " " << ab << endl;
            a = a - (potrebanbrjedinica - (b + ab));
            ab = 0;
            b = 0;
            }
            }
            else if (potrebanbrjedinica >= ab && potrebanbrjedinica >= ab + a && potrebanbrjedinica >= ab + b && potrebanbrjedinica >= ab + a + b && potrebanbrjedinica <= ab + a + b + o) {
            cout << potrebanbrjedinica - (a + b + ab) << " " << a << " " << b << " " << ab << endl;
            o = o - (potrebanbrjedinica - (a + b + ab));
            a = 0;
            b = 0;
            ab = 0;
            }
            }
        brojac0++;
        }
}